# 💫 Spacebin JS

![Codacy grade](https://img.shields.io/codacy/grade/ac3c94dc66484ccf9cea334b21b6d78f) ![GitHub last commit](https://img.shields.io/github/last-commit/spacebin-org/spacebin-js) ![GitHub](https://img.shields.io/github/license/spacebin-org/spacebin-js?color=127681)

> Node.js library for interacting with Spacebin instances

## Installation

  * Using yarn: `yarn add spacebin-js`
  * Using npm: `npm i spacebin-js`

## Usage

```js
import { Spacebin } from 'spacebin-js'

const spacebin = new Spacebin({
  host: 'http://localhost:7777'
})

spacebin.getDocument('Bc5tR7d9arhh')
  .then(({ id, content }) => {
    // ...
  })
  .catch(err => {
    throw new Error(err)
  })
```

## Contributors

  * [Luke Whrit <me@lukewhrit.xyz>](https://github.com/lukewhrit) - Primary developer and maintainer.

## License

This project is licensed under the 3-Clause "Clear" BSD license, the same license as all other spacebin core team projects. A copy of this license can be found in [`LICENSE.md`](LICENSE.md)
